--this you can change if you want
local ShootRate = 0.2--how smaller how faster
local EnemieRate = 0.5--how smaller how faster
local BulletSpeed = 300--how bigger how faster
local ShipSpeed = 100--how bigger how faster
local EnemieSpeed = 50--how bigger how faster
local ShipSize = 80--how bigger how bigger
local BulletSize = 50--how bigger how bigger
local EnemieSize = 60--how bigger how bigger
--do not change things below



math.randomseed(os.time())
local Ship = {
	Position = {x = 400, y = 300},
	Direction = 0
}
local ShipImage = love.graphics.newImage("Ship.png")
local ShipScale = {x = ShipSize/love.graphics.newImage("Ship.png"):getWidth(), y = ShipSize/love.graphics.newImage("Ship.png"):getHeight()}
local ShipOffset = {x = love.graphics.newImage("Ship.png"):getWidth()/2,y = love.graphics.newImage("Ship.png"):getHeight()/2}

local Bullets = {}
local BulletImage = love.graphics.newImage("Bullet.png")
local BulletScale = {x = BulletSize/BulletImage:getWidth(), y = BulletSize/BulletImage:getHeight()}
local BulletOffset = {x = BulletImage:getWidth()/2,y = BulletImage:getHeight()/2}
local BulletTimer = 0

local Enemies = {}
local EnemieImage = love.graphics.newImage("Enemie.png")
local EnemieScale = {x = EnemieSize/EnemieImage:getWidth(), y = EnemieSize/EnemieImage:getHeight()}
local EnemieOffset = {x = EnemieImage:getWidth()/2,y = EnemieImage:getHeight()/2}
local EnemieTimer = 0

function love.update(dt)
	BulletTimer = BulletTimer + dt
	EnemieTimer = EnemieTimer + dt
	--make bullets move
	for bi,b in pairs(Bullets) do
		b.Position.x = b.Position.x+(math.cos(b.Direction)*dt*BulletSpeed)
		b.Position.y = b.Position.y+(math.sin(b.Direction)*dt*BulletSpeed)
		--collision detection with enemies(SIMPLE DISTANCE CHECK COLLISION DETECTION!!!)
		for ei,e in pairs(Enemies) do
			distance = ((e.Position.x-b.Position.x)^2+(e.Position.y-b.Position.y)^2)^0.5
			if distance < EnemieSize/2+BulletSize/2 then
				table.remove(Enemies,ei)
				table.remove(Bullets,bi)
			end
		end
		--check if out of screen
		if b.Position.x < 0 or b.Position.x > 800 or b.Position.y < 0 or b.Position.y > 600 then
			table.remove(Bullets,bi)
		end
	end
	--make Enemies move
	for ei,e in pairs(Enemies) do
		e.Position.x = e.Position.x+(math.cos(e.Direction)*dt*EnemieSpeed)
		e.Position.y = e.Position.y+(math.sin(e.Direction)*dt*EnemieSpeed)
		e.Direction = math.atan2(e.Position.x-Ship.Position.x,Ship.Position.y-e.Position.y)+math.pi/2
		--collision detection with Ship(SIMPLE DISTANCE CHECK COLLISION DETECTION!!!)
		distance = ((e.Position.x-Ship.Position.x)^2+(e.Position.y-Ship.Position.y)^2)^0.5
		if distance < EnemieSize/2+ShipSize/2 then
			Enemies = {}
			Bullets = {}
			Ship.Position.x = 400
			Ship.Position.y = 300
		end
	end
	--direct ship to mouse
	Ship.Direction = math.atan2(love.mouse.getX()-Ship.Position.x,Ship.Position.y-love.mouse.getY())-math.pi/2
	--make ship move
	if love.mouse.isDown("l") then
		Ship.Position.x = Ship.Position.x+(math.cos(Ship.Direction)*dt*ShipSpeed)
		Ship.Position.y = Ship.Position.y+(math.sin(Ship.Direction)*dt*ShipSpeed)
	end
	--make bullets
	if love.mouse.isDown("r") then
		if BulletTimer > ShootRate then
			BulletTimer = 0
			local Bullet = {
				Position = {x = Ship.Position.x, y = Ship.Position.y},
				Direction = Ship.Direction
			}
			table.insert(Bullets,Bullet)
		end
	end
	--make Enemie
	if EnemieTimer > EnemieRate then
		EnemieTimer = 0
		local Enemie = {
			Position = {x = math.random(1,800), y = math.random(1,600)},
			Direction = 0
		}
		table.insert(Enemies,Enemie)
	end
end
function love.draw()
	for i,v in pairs(Bullets) do
		love.graphics.draw(BulletImage,v.Position.x,v.Position.y,v.Direction,BulletScale.x,BulletScale.y,BulletOffset.x,BulletOffset.y)
	end
	for i,v in pairs(Enemies) do
		love.graphics.draw(EnemieImage,v.Position.x,v.Position.y,v.Direction,EnemieScale.x,EnemieScale.y,EnemieOffset.x,EnemieOffset.y)
	end
	love.graphics.draw(ShipImage,Ship.Position.x,Ship.Position.y,Ship.Direction,ShipScale.x,ShipScale.y,ShipOffset.x,ShipOffset.y)
end


